    var vm = new Vue({
      el: "#accordion",
      data: {
        url: "http://localhost:40011/",
        tabs: ["Инофромация", "Считывание идентификаторов", "Добавить удаленых пользователей", "Установка режима шифрования Mifare идентификаторов", "Выпуск зашифрованных идентификаторов Mifare", "Установка защиты JSON",
          "Параметры e-mail cервера"
        ],
        Page: 1,
        Version: {
          Model: "",
          Serial: "",
          Version: "",
        },
        VersionText: false,
        Quantity: 0,
        QuantText: false,
        Encrypted: {
          EncryptedMobile: false,
          EncryptedMifare: false,
        },
        EncryptedText: false,
        SelectFormat: "Hex5",
        formats: ["Raw", "FacilityCode", "Dec3", "Hex3", "Hex4", "Hex5", "Hex5f3", "Hex6", "Hex7", "Hex8"],
        IdentifiersList: [],
        IDListText: false,
        RemoteId: {
          Identifier: "",
          ActivationLink: "",
        },
        sallGate: 'asdasd /r dasdasdas',
        wsConnect: false,
        RemoteIDText: false,
        RemoteUser: {
          Url: "",
          UserCode: "",
          SendEmail: false,
          Email: "",
          OutputTypeSelect: false,
          OutputAs: "Hex5",
        },
        SMTPData: {
          SmtpServerEnabled: false,
          SMTPEncrypted: false,
          SMTPServer: "",
          SMTPPort: '',
          SMTPUser: "",
          SMTPPassword: "",
          SMTPSendFrom: "",
        },
        readerProps: {
          BLEEnabled: false,
          MifareEnabled: false,
          FSKEnabled: false,
          ASKEnabled: false,
        },
        ReaderInstallProps: {
          BLEEnabled: false,
          MifareEnabled: false,
          FSKEnabled: false,
          ASKEnabled: false,
        },
        MifareTypeEncrypted: 'Hex5',
        EncryptIDs: [],
        EncrIDtext: false,
        AuthorizationRequired: false,
        Authorization: {
          user: "",
          password: "",
        },
        AuthorResult: false,
        MifareSecureTypes: ["только шифрование", "шифрование и внутренний код", "выключить режим шифрования"],
        MifareSelectSecure: "",
        SecMifRes: false,
        WatchPassPole: false,
        WatchCodePole: false,
        MobileIdSecureTypes: ["включить режим шифрования", "выключить режим шифрования"],
        MobileIdSelectSecure: "",
        SecMobRes: false,
        WatchPassPoleMobileId: false,
        SMoptions: {
          MifarePassword: "",
          MobileIdPassword: "",
          StartingCode: ""
        },
        Active: false,
        SecuredMifare: false,
        SecuredMobileId: false,
        AuthActive: false,
        EmailServerProps: false,
        SmtpServerEnabled: false,
        ReqType: false,
        ReaderTypeText: false

      },
      computed: {

      },
      methods: {
        OpenPart: function(x) {
          (this.Page==x?this.Page=0:this.Page=x)
        },
        Viewpart:function (x) {
          if (this.Page==x) {
            return 'open'
          }
        },
        GetVersion: function() {
          this.$http.post(this.url + "GetVersion", {}).then(function(response) {
              this.Version = response.data;
              this.VersionText = true;
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        GetQuantity: function() {
          this.$http.post(this.url + "GetQuantity", {}).then(function(response) {
              this.QuantText = true;
              this.Quantity = response.data.Quantity;
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        isEncrypted: function() {
          this.$http.post(this.url + "isEncrypted", {}).then(function(response) {
              this.Encrypted = response.data;
              this.EncryptedText = true;
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        GetIdentifiers: function() {
          var data = {
            OutputAs: this.SelectFormat,
          }
          this.$http.post(this.url + "GetIdentifiers", data).then(function(response) {
              this.IDListText = true;
              let ids = response.data.Identifiers;
              for (var i = 0; i < response.data.Identifiers.length; i++) {
                this.IdentifiersList.push(response.data.Identifiers[i])
              }
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        IdentifiersConnected: function() {
          if (!this.wsConnect) {
            this.ws = new WebSocket('ws://localhost:40013/');
            this.ws.onmessage = function(evt) {
              let res = JSON.parse(evt.data);
              vm.IdentifiersList.push(res.Identifiers[0]);
            };
            this.wsConnect = true;
            this.ws.onopen = function() {
              let id = {
                'OutputAs': vm.SelectFormat
              }
              vm.ws.send(JSON.stringify(id))
            }
            this.ws.onerror = function() {
              console.log(this.readyState);
            }
          } else {
            this.ws.send({
              GetIdentifiers: {
                OutputAs: this.SelectFormat
              }
            })
          }
          this.IDListText = true;
        },
        IdentifiersColsed: function() {
          this.ws.close();
          this.wsConnect = false;
        },
        IdentifiersClear: function() {
          this.IdentifiersList = [];
        },
        CheckID: function() {
          this.RemoteUser.UserCode = this.getParameterByName('id')
          // console.log(this.getParameterByName('id').length);
        },
        getParameterByName: function(name) {
          name = name.replace(/[\[\]]/g, "\\$&");
          var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
            results = regex.exec(this.RemoteUser.Url);
          if (!results) return null;
          if (!results[2]) return '';
          return decodeURIComponent(results[2].replace(/\+/g, " "));
        },
        IssueRemoteIdentifier: function() {
          var data = {
            UserCode: this.RemoteUser.UserCode,
            SendEmail: this.RemoteUser.SendEmail,
            OutputTypeSelect: false,
          }
          if (this.RemoteUser.SendEmail) {
            data.Email = this.RemoteUser.Email
          }
          if (this.RemoteUser.OutputTypeSelect) {
            data.OutputAs = this.RemoteUser.OutputAs
          }
          this.RemoteIDText = true;
          this.$http.post(this.url + "IssueRemoteIdentifier", data).then(function(response) {
              this.RemoteId = response.data;
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        SetupEmailServer: function() {
          var data = {
            SmtpServerEnabled: this.SMTPData.SmtpServerEnabled,
            SMTPEncrypted: this.SMTPData.SMTPEncrypted,
            SMTPServer: this.SMTPData.SMTPServer,
            SMTPPort: this.SMTPData.SMTPPort,
            SMTPUser: this.SMTPData.SMTPUser,
            SMTPPassword: this.SMTPData.SMTPPassword,
            SMTPSendFrom: this.SMTPData.SMTPSendFrom,
          }
          this.$http.post(this.url + "SetupEmailServer", data).then(function(response) {
              this.EmailServerProps = true;
              this.SmtpServerEnabled = response.data.SmtpServerEnabled;
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        GetReaderType: function() {
          this.ReqType = false;
          this.$http.post(this.url + "GetReaderType", {}).then(function(response) {
              this.readerProps = response.data;
              this.ReaderTypeText = true;
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        SetReaderType: function() {
          this.ReqType = true;
          var data = {
            BLEEnabled: this.readerProps.BLEEnabled,
            MifareEnabled: this.readerProps.MifareEnabled,
            FSKEnabled: this.readerProps.FSKEnabled,
            ASKEnabled: this.readerProps.ASKEnabled,
          }
          this.$http.post(this.url + "SetReaderType", data).then(function(response) {
              this.ReaderInstallProps = response.data;
              this.ReaderTypeText = true;
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        SetRedProps: function() {
          this.ReqType = true;
        },
        GetEncryptedMifareID: function() {
          var data = {
            OutputAs: this.MifareTypeEncrypted
          }
          this.$http.post(this.url + "GetEncryptedMifareID", data).then(function(response) {
              this.EncrIDtext = true;
              this.EncryptIDs = response.data;
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        ErrorView: function(err) {
          alert("Ошибка " + err.code + ":" + err.message)
        },
        AuthorizationInstall: function() {
          if (this.AuthActive) {
            var data = {
              user: this.Authorization.user,
              password: this.Authorization.password,
            }
          } else {
            var data = {
              user: "",
              password: "",
            }
          }
          this.$http.post(this.url + "Authorization", data).then(function(response) {
              this.AuthorResult = true;
              this.AuthorizationRequired = response.data.AuthorizationRequired;
              this.Authorization = {
                user: "",
                password: "",
              }
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        ChangeSecureMifIDs: function() {
          if (this.MifareSelectSecure == "только шифрование") {
            var data = {
              MifarePassword: this.SMoptions.MifarePassword,
            };
          } else if (this.MifareSelectSecure == "шифрование и внутренний код") {
            var data = {
              MifarePassword: this.SMoptions.MifarePassword,
              StartingCode: this.SMoptions.StartingCode,
            };
          } else {
            var data = {
              MifarePassword: ''
            };
          }
          this.SecureMifareIDs(data)
        },
        SecureMifareIDs: function(data) {
          this.$http.post(this.url + "SecureMifareIDs", data).then(function(response) {
              this.SecMifRes = true;
              this.SecuredMifare = response.data.EncryptedMifare;
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        WatchPoleEncr: function() {
          this.WatchPassPole = (this.MifareSelectSecure == "только шифрование" || this.MifareSelectSecure == "шифрование и внутренний код");
          this.WatchCodePole = (this.MifareSelectSecure == "шифрование и внутренний код");
        },
        ChangeSecureMobIDs: function() {
          if (this.MobileIdSelectSecure == "включить режим шифрования") {
            var data = {
              MobilePassword: this.SMoptions.MobileIdPassword,
            };
          } else {
            var data = {
              MobilePassword: ''
            };
          }
          this.SecureMobileIDs(data)
        },
        SecureMobileIDs: function(data) {
          this.$http.post(this.url + "SecureMobileIDs", data).then(function(response) {
              this.SecMobRes = true;
              this.SecuredMobileId = response.data.EncryptedMobile;
            },
            function(error) {
              this.ErrorView(error.data)
            });
        },
        WatchPoleEncrMobileId: function() {
          this.WatchPassPoleMobileId = (this.MobileIdSelectSecure == "включить режим шифрования");
        },
        ToogleMenu: function() {
          this.Active = !this.Active
        },
        CheckLast: function(array, index) {

          return array.length != index + 1
        }
      },

    })
